:- use_module(library(plunit)).

:- begin_tests(arithmetic_rules, [setup((clear_model, reset_options))]).

test('simplify1', []) :-
  simplify(a+2*a, 3*a),
  simplify(-1*a/b+2*a/b, a/b).

test('distribute1', [true(Out == a * a + a * b + c)]) :-
  distribute(a * (a + b) + c, Out).

test('distribute2', []) :-
  distribute((a+b)^2, a*a+a*b+(b*a+b*b)),
  distribute((a+b)^ -2, (a+b)^ -2).

test('determine_sign', []) :-
  parameter([k1 = 2, k2 = 3]),
  determine_sign((a+1)^2, pos),
  determine_sign((a-1)^3, dnk),
  determine_sign(-exp(a), neg),
  determine_sign(a/(a+1), pos),
  determine_sign((2+a)*0, zero),
  determine_sign((x-1)^k1, pos),
  determine_sign((x-1)^k2, dnk).


test('is_null', []) :-
  is_null(a*0*1/2),
  \+(is_null(a*b/0)).

:- end_tests(arithmetic_rules).
