:- use_module(matrix).

%! check_error(Result, Target, Max_Error)
%
% check if result and target differ by no more than Max_Error

check_error([], [], _) :- !.

check_error([R|TR], [T|TT], Epsilon) :-
  abs(R-T) < Epsilon,
  check_error(TR, TT, Epsilon).


:- begin_tests(matrix, [setup((clear_model, reset_options))]).

test(ludcmp_matrix_22) :-
	matrix:ludcmp_matrix([[-5,-4],[1,8]],X),
	X = [[-5,-4],[-0.2,7.2]].

test(lusubst_33) :-
	matrix:ludcmp_matrix([[2,1,4],[1,0,1],[6,4,2]],Decmp),
	matrix:lusubst([9,3,6],X),
	Decmp = [[1,0,1],[6,4,-4],[2,0.25,3.0]],
	X = [1.0,-1.0,2.0].

test(solve_linear_algebra_1) :-
  matrix:solve_linear_problem([[ 1.0, 2.0, 0.0,-1.0],
                        [ 3.0,-2.0, 1.0, 0.0],
                        [-2.0, 0.0, 0.0, 4.0],
                        [ 1.0, 1.0,-1.0, 0.0]],
                       [-2.0, 7.0, 2.0,-2.0],X),
  check_error(X, [1,-1,2,1], 0.001).

:- end_tests(matrix).
