:- module(
  sbml,
  [
    readSBML/2,
    sbmlDocument_getNumErrors/2,
    sbmlDocument_printErrors/2,
    sbmlDocument_getModel/2,
    sbmlDocument_free/1,
    model_getListOfReactions/2,
    model_getListOfSpecies/2,
    model_getListOfCompartments/2,
    model_getListOfParameters/2,
    model_getListOfRules/2,
    model_getSpeciesById/3,
    model_getTimeUnits/2,
    model_getSubstanceUnits/2,
    model_getVolumeUnits/2,
    listOf_get/3,
    listOf_size/2,
    reaction_getKineticLaw/2,
    reaction_getListOfReactants/2,
    reaction_getListOfModifiers/2,
    reaction_getListOfProducts/2,
    reaction_getReversible/2,
    reaction_getId/2,
    kineticLaw_getMath/2,
    kineticLaw_getListOfParameters/2,
    speciesReference_getSpecies/2,
    speciesReference_getStoichiometry/2,
    modifierSpeciesReference_getSpecies/2,
    species_getName/2,
    species_getId/2,
    species_getCompartment/2,
    species_getInitialAmount/2,
    species_getInitialConcentration/2,
    species_hasOnlySubstanceUnits/1,
    parameter_getId/2,
    parameter_getValue/2,
    rule_getVariable/2,
    rule_getMath/2,
    function_getName/2,
    function_getBody/2,
    function_getNumArguments/2,
    function_getArgument/3,
    is_assignment/1,
    compartment_getId/2,
    compartment_getVolume/2
  ]
).


:- use_foreign_library(foreign(sbml_swiprolog)).
