:- use_module(library(plunit)).

:- use_module(podeize).

:- begin_tests(podeize, []).

test(polynomize_ode_1, [nondet]) :-
  polynomize_ode([d(a)/dt = exp(a)], _Out, Trans_raw),
  sort(Trans_raw, [('A'->exp(a))]).

test(polynomize_ode_2, [nondet]) :-
  polynomize_ode([d(a)/dt = sin(a)], _Out, Trans_raw),
  sort(Trans_raw, [('A'->sin(a)),('B'->cos(a))]).

test(polynomize_ode_bournez, [nondet]) :-
  polynomize_ode([d(a)/dt = sin(b)^2, d(b)/dt = a*cos(b) - exp(exp(a)+t)], _Out, Trans_raw),
  sort(Trans_raw, [('A'->sin(b)),('B'->exp(exp(a)+t)),('C'->cos(b)),('D'->exp(a))]).

test(derivation) :-
  pode:complete_derivation(b+t, [d(a)/dt = a, d(b)/dt = t], Expr),
  simplify(Expr, 1+t).

test(new_variable) :-
  set_counter(variable_id, 0),
  pode:new_variable(['B'], 'A'),
  pode:new_variable(['B'], 'C').

:- end_tests(podeize).
